$ViperCrash = 1;
if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
    if(!$RTB::Hooks::ServerControl)
    {
        exec("Add-Ons/System_ReturnToBlockland/hooks/servercontrol.cs");
    }
    RTB_registerPref("Viper Impact Crash","Viper","$Vipercrash","list Off 0 On 1","Vehicle_Viper",0,0,1);
}
function wheeledVehicle::isfirstperson(%something)
{
	return false; //What the hell is this?
}
datablock WheeledVehicleTire(ViperfakeTire)
{
   shapeFile = "";
	
	mass = 0;
   radius = 0;
   staticFriction = 0;
   kineticFriction = 0;
   restitution = 0.0;	

   // Spring that generates lateral tire forces
   lateralForce = 10;
   lateralDamping = 10;
   lateralRelaxation = 0.01;

   // Spring that generates longitudinal tire forces
   longitudinalForce = 10;
   longitudinalDamping = 10;
   longitudinalRelaxation = 0.01;
};
datablock WheeledVehicleSpring(ViperfakeSpring)
{
   length = -20.2;        // Suspension trave 0.2
   force = 10;        // Spring force
   damping = 10;      // Spring damping
   antiSwayForce = 1.1;   // Lateral anti-sway force
};
datablock ParticleData(ViperTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 70;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 50.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 0.0 0.0 0.9";
	colors[1]     = "1.0 0.0 0.0 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(ViperTrailEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 1;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ViperTrailParticle";
};
datablock ParticleData(ViperGunExplosionParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 70;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 50.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 0.0 0.0 0.9";
	colors[1]     = "1.0 0.0 0.0 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(ViperGunExplosionEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 1;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ViperGunExplosionParticle";
};
datablock ExplosionData(ViperGunExplosion)
{
   //explosionShape = "";
	soundProfile = bulletHitSound;

   lifeTimeMS = 150;

   particleEmitter = VipergunExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "1 0.0 0.0 0.9";
   lightEndColor = "0 0 0";
};
AddDamageType("Viper",   '<bitmap:add-ons/Weapon_Gun/CI_gun> %1',    '%2 <bitmap:add-ons/Weapon_Gun/CI_gun> %1',0.2,1);
datablock ProjectileData(ViperProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 45;
   directDamageType    = $DamageType::Viper;
   radiusDamageType    = $DamageType::Viper;


   brickExplosionRadius = 3;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 15;
   brickExplosionMaxVolume = 10;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 15;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 400;
   explosion           = ViperGunExplosion;
   particleEmitter     = "ViperTrailEmitter"; //bulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 4000;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Viper Weapon";
   explodeOnDeath = 1;
};

datablock ParticleData(ViperShotParticle)
{
    dragCoefficient      = 0;
    gravityCoefficient   = -0.5;
    inheritedVelFactor   = 0.2;
    constantAcceleration = 0.0;
    lifetimeMS           = 40;
    lifetimeVarianceMS   = 0;
    textureName          = "base/data/particles/star1";
    spinSpeed        = 10.0;
    spinRandomMin        = -500.0;
    spinRandomMax        = 500.0;

    colors[0]     = "0.9 0.9 0 0.3";
    colors[1]     = "1 0.5 0.2 0.5";
    colors[2]     = "1 0.5 0.2 0.0";

    sizes[0]      = 3.55;
   sizes[1]      = 0.80;
    sizes[2]      = 0.10;

   times[0] = 0.0;
   times[1] = 0.1;
   times[2] = 1.0;

    useInvAlpha = false;
};
datablock ParticleEmitterData(ViperShotEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 106.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 1;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ViperShotParticle";
};
datablock ShapeBaseImageData(ViperMachineGun1Image)
{
   // Basic Item properties
   shapeFile = "base/data/shapes/empty.dts";
   emap = false;

   className = "WeaponImage";
   item = BowItem;
   ammo = " ";
   projectile = ViperProjectile;
   projectileType = Projectile;
   mountPoint = 3; //1

	//casing = gunShellDebris;
	//shellExitDir        = "1.0 -1.3 1.0";
	//shellExitOffset     = "0 0 0";
	//shellExitVariance   = 15.0;	
	//shellVelocity       = 7.0;


   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
   	stateTimeoutValue[2] = 0.06;
	stateTransitionOnTimeout[2]     = "Smoke";
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= ViperShotEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= Gunshot1Sound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= "";
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Ready";

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateSequence[4]	= "Ready";

};
datablock ShapeBaseImageData(ViperMachineGun2Image : ViperMachineGun1Image)
{
   // Basic Item properties
   shapeFile = "base/data/shapes/empty.dts";
   emap = false;

   className = "WeaponImage";
   item = BowItem;
   ammo = " ";
   projectile = ViperProjectile;
   projectileType = Projectile;
   mountPoint = 7; //1

};
function ViperMachineGun1Image::onFire(%this,%obj,%slot)
{
   if(!isObject(%obj.getControllingClient()))
      return;
   
   %vehicle = %obj.getObjectMount();
   
   //if(!isObject(%vehicle))
      //return;
   
   //if(%obj.getDamageLevel() >= 1.0)
      //return;
   
   %old = %obj.client;
   %obj.client = %obj.getControllingClient();
	%projectile = %this.projectile;
	%spread = 0.0000; //0.0015
	%shellcount = 1;
	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getEyeVector();
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}

   %obj.setImageTrigger(0,1);
   //Parent::onFire(%this,%obj,%slot);
   %obj.client = %old;
}
function ViperMachineGun2Image::onFire(%this,%obj,%slot)
{
   if(!isObject(%obj.getControllingClient()))
      return;
   
   %vehicle = %obj.getObjectMount();
   
   //if(!isObject(%vehicle))
      //return;
   
   //if(%obj.getDamageLevel() >= 1.0)
      //return;
   
   %old = %obj.client;
   %obj.client = %obj.getControllingClient();
	%projectile = %this.projectile;
	%spread = 0.0000; //0.0015
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %vector = %obj.getEyeVector();
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
   //Parent::onFire(%this,%obj,%slot);
   %obj.client = %old;
}
datablock WheeledVehicleData(ViperVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./BSGViper.dts";
	emap = true;
	minMountDist = 3;
   
   numMountPoints = 1;
   mountThread[0] = "sit";



	maxDamage = 300.00;
	destroyedLevel = 200.00;
	energyPerDamagePoint = 160;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0 1";
   //massBox = "2 5 1";

	maxSteeringAngle = 0.9785;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	//tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 25;         // Far distance from vehicle
	cameraOffset = 7;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.4;
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = false;	

	defaultTire   = ViperTire; //ATENTIRE
	defaultSpring   = ViperSpring;
	// flatTire	   = ViperFlatTire;
	// flatSpring	   = ViperFlatSpring;

   numWheels = 3;

	// Rigid Body
	mass = 200;
	density = 0.5; //5.0
	drag = 0.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 25;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 8000; //8000;       // Engine power
	engineBrake = 4000;         // Braking when throttle is 0
	brakeTorque = 6000;        // When brakes are applied
	maxWheelSpeed = 20;        // Engine scale by current speed / max speed

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

   isSled = false;

   forwardThrust		= 5000;
	reverseThrust		= 2000;
	lift			= 100;
	maxForwardVel		= 100;
	maxReverseVel		= 15;
	horizontalSurfaceForce	= 150;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
	verticalSurfaceForce	= 160; 
	rollForce		= 10000;
	yawForce		= 10000;
	pitchForce		= 10000;
	rotationalDrag		= 0.5;
	stallSpeed		= 5;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;

   uiName = "Viper";
	rideable = true;
		lookUpLimit = 0.50;
		lookDownLimit = 0.50;

	paintable = true;
   
   damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

   damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

   numDmgEmitterAreas = 1;

   initialExplosionProjectile = ViperExplosionProjectile;
   initialExplosionOffset = 0;         //offset only uses a z value for now

   burnTime = 10000;

   finalExplosionProjectile = ViperFinalExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now


   minRunOverSpeed    = 5;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 15;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 3.2; //how hard a person you're running over gets pushed
   
      // Advanced Steering
   steeringAutoReturn = false;
   // steeringAutoReturnRate = 0.9;
   // steeringAutoReturnMaxSpeed = 10;
   steeringUseStrafeSteering = false;
   // steeringStrafeSteeringRate = 0.1;
   
   minFJetStreamSpeed = 30;
};



package ViperPackage
{

function ViperVehicle::onadd(%this,%obj)
{ 
	parent::onadd(%this,%obj);

   for(%i = 0; %i < %this.numWheels; %i++)
   {
      %obj.setWheelTire(%i, %this.defaultTire);
      %obj.setWheelSpring(%i, %this.defaultSpring);
   }
if(%this.numWheels > 0)
{
	%obj.setWheelSpring(0,ViperSpring);
	%obj.setWheelSpring(1,ViperSpring);
	%obj.setWheelSpring(2,ViperSpring);

	%obj.setWheelSteering(0,1);
	%obj.setWheelSteering(1,0);
	%obj.setWheelSteering(2,0);

	%obj.setWheelPowered(0,true);
        %obj.setWheelPowered(1,true);
	%obj.setWheelPowered(2,true);
}
	//%obj.mountImage(ViperMachineGunImage, 2);
	%obj.Gearnum = 1;
	Vipertire.radius = 0.4; //idk something went wrong
	    
}
function Vipervehicle::onRemove(%this,%obj)
{
   %obj.unMountImage(3);
   %obj.unMountImage(0);
   %obj.unMountImage(8);
   %obj.unMountImage(7);
   %obj.unMountImage(1);
}
function Vipervehicle::onDriverLeave(%this, %obj)
{
	%obj.unmountimage(0);
	%obj.unmountimage(3);
   %obj.client = "";
   Parent::onDriverLeave(%this, %obj);
}
	function armor::onMount(%this,%obj,%col,%slot)
	{
		Parent::onMount(%this,%obj,%col,%slot);
		if(%col.getDataBlock() == ViperVehicle.getId())
		{
			%col.client = %obj.client;
			if(%col.Gearnum == 0)
			{
				%col.mountImage(ViperMachinegun1Image, 3);
				%col.mountImage(ViperMachinegun2Image, 0);
			}
		}

	}

   function Armor::onTrigger(%this, %obj, %triggerNum, %val)
   {
      %mount = %obj.getObjectMount();
      if(isObject(%mount) && %mount.getDatablock() == Vipervehicle.getID() && %triggerNum == 0)
      {
         %mount.setImageTrigger(3, %val); //2
	 //%mount.setImageTrigger(0, %val);
	 //%mount.setImageTrigger(7, %val);
      }

      Parent::onTrigger(%this, %obj, %triggerNum, %val);
   }
function servercmdLight(%client)
{
		%player = %client.player;
		if(%player.getClassName()$="Player")
		{
		%obj= %player.getObjectMount();
			if(!isObject(%obj))
			{
				return Parent::servercmdLight(%client);
				
			}
   		if($Sim::Time > %obj.nextGearTime)
   		{
		
			if(!%obj || %obj.getDataBlock() != ViperVehicle.getId()) {return Parent::servercmdLight(%client);}		

			if(!isObject(%obj))
			{
				return Parent::servercmdLight(%client);
				
			}
			
	
      			if(%obj.Gearnum == 1)
      			{
					for(%i = 0; %i < 2; %i++)
					{
						%obj.schedule(1400,setWheelTire,%i, ViperFaketire);
						%obj.schedule(1400,setWheelspring,%i, ViperFakespring);
					}
				%obj.mountImage(ViperMachinegun1Image, 3);
				%obj.mountImage(ViperMachinegun2Image, 0);
				%obj.playthread(1,"Retract");
        			%obj.Gearnum = 0;
				commandToClient(%client,'bottomPrint',"<just:right><font:impact:24><color:fff000>Gear up.<font:impact:34>", 1, 1, 1, 1);
      			}
     			else
      			{
					for(%i = 0; %i < 2; %i++)
					{
						%obj.schedule(1400,setWheelTire,%i, Vipertire);
						%obj.schedule(1400,setWheelspring,%i, Viperspring);
					}
				%obj.unmountimage(0);
				%obj.unmountimage(3);
				%obj.playthread(1,"Extend");
        			%obj.Gearnum = 1;
				commandToClient(%client,'bottomPrint',"<just:right><font:impact:24><color:fff000>Gear down.<font:impact:34>", 1, 1, 1, 1);
      			}
      		%obj.nextGearTime = $Sim::Time+0.5;
  		}
		}
}

function ViperVehicle::onImpact(%this,%obj,%data)
{
	if($Vipercrash == 1)
	{
	%speed = vectorLen(%obj.getVelocity());
	//Lets the pilot have an easy landing
	if(%obj.Gearnum == 1)
		%obj.speedlimit = 30;
	else
		%obj.speedlimit = 5;
	
	if(%speed > %obj.speedlimit )
	{
		if(%obj.destroyed)
            return;
		%obj.setDamageLevel(0);
		%obj.destroyed = 1;

		%trans = %obj.getTransform();
		%p = new Projectile()
		{
			dataBlock = ViperfinalExplosionProjectile;
			initialVelocity  = "0 0 0";
			initialPosition  = %trans;
			 client = %obj.getmountedobject(0).client;
               sourceClient = %obj.getmountedobject(0).client;
		};
		MissionCleanup.add(%p);


		%obj.schedule(10,"delete");
		if(isObject(%obj.spawnBrick.client.minigame))
			%respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
		%obj.spawnBrick.schedule(%respawn+1000,"spawnVehicle");
	}
	}
	
}
};
activatePackage(ViperPackage);
